From dc3025504be041fe19dd9ad3f4f8bfb131787ddb Mon Sep 17 00:00:00 2001
From: Jehan-Guillaume de Rorthais <jgdr@dalibo.com>
Date: Mon, 10 Feb 2020 11:22:45 +0100
Subject: [PATCH] Simpler FK regression test with mult-level partitions.

Avoid join between relation having on the FK to detect FK violation.
The planner might optimize this considering the PK must exist on the
referenced side at some point, effectively masking a bug this test
try to detect.

Reported-by: Tom Lane
---
 src/test/regress/expected/foreign_key.out | 14 ++++++++------
 src/test/regress/sql/foreign_key.sql      |  6 ++----
 2 files changed, 10 insertions(+), 10 deletions(-)

diff --git a/src/test/regress/expected/foreign_key.out b/src/test/regress/expected/foreign_key.out
index 9e1d749601..07bd5b6434 100644
--- a/src/test/regress/expected/foreign_key.out
+++ b/src/test/regress/expected/foreign_key.out
@@ -2456,12 +2456,14 @@ CREATE SCHEMA fkpart9
 INSERT INTO fkpart9.pk VALUES (35);
 INSERT INTO fkpart9.fk VALUES (35);
 DELETE FROM fkpart9.pk WHERE a=35;
-SELECT fk.fk_a, pk.a
-FROM fkpart9.fk
-LEFT JOIN fkpart9.pk ON fk.fk_a = pk.a
-WHERE fk.fk_a=35;
- fk_a | a 
-------+---
+SELECT * FROM fkpart9.pk;
+ a 
+---
+(0 rows)
+
+SELECT * FROM fkpart9.fk;
+ fk_a 
+------
 (0 rows)
 
 DROP SCHEMA fkpart9 CASCADE;
diff --git a/src/test/regress/sql/foreign_key.sql b/src/test/regress/sql/foreign_key.sql
index b03a6670a2..c5c9011afc 100644
--- a/src/test/regress/sql/foreign_key.sql
+++ b/src/test/regress/sql/foreign_key.sql
@@ -1735,8 +1735,6 @@ CREATE SCHEMA fkpart9
 INSERT INTO fkpart9.pk VALUES (35);
 INSERT INTO fkpart9.fk VALUES (35);
 DELETE FROM fkpart9.pk WHERE a=35;
-SELECT fk.fk_a, pk.a
-FROM fkpart9.fk
-LEFT JOIN fkpart9.pk ON fk.fk_a = pk.a
-WHERE fk.fk_a=35;
+SELECT * FROM fkpart9.pk;
+SELECT * FROM fkpart9.fk;
 DROP SCHEMA fkpart9 CASCADE;
-- 
2.20.1

